<template>
  <div>
    <v-app-bar height="40">
      <v-btn icon color="grey">
        <v-icon>mdi-sync</v-icon>
      </v-btn>
      <v-btn @click="addConnection" icon :disabled="!connection" color="green">
        <v-icon>mdi-plus-thick</v-icon>
      </v-btn>
    </v-app-bar>
    <v-treeview
      :open="open"
      :items="connections"
      activatable
      item-key="name"
      open-on-click
      :active.sync="connectionsSelected"
      return-object
    >
      <template v-slot:prepend="{ item, open }">
        <v-icon v-if="item.folder">
          {{ open ? "mdi-database-minus" : "mdi-database-plus" }}
        </v-icon>
        <v-icon v-else>
          mdi-database
        </v-icon>
      </template>
    </v-treeview>
  </div>
</template>
<script>
import axios from "axios";
export default {
  name: "Component-Connections",
  data: () => ({
    open: ["connections"],
    connectionsSelected: [],
    connections: [
      {
        name: "Conexiones",
        folder: true,
        children: []
      }
    ]
  }),
  computed: {
    connection() {
      if (this.connectionsSelected.length > 0) {
        return this.connectionsSelected[0];
      } else {
        return null;
      }
    }
  },
  methods: {
    getConnections() {
      const self = this;
      axios
        .get("oracle/connections")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setConnections(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    setConnections(connections) {
      if (connections) {
        this.connections[0].children = connections;
      }
    },
    addConnection() {
      const connection = this.connection;
      this.$root.$emit("newConnection", connection);
    }
  },
  destroyed() {
    this.$root.$off("newConnection");
  },
  created() {
    this.getConnections();
  }
};
</script>
